# ej2-treegrid

The TreeGrid component is a feature-rich control used to visualize self-referential hierarchical data effectively in a tabular format.. It will pull data from a data source, such as array of JSON objects, `OData web services`, or [`DataManager`](http://ej2.syncfusion.com/documentation/data) binding data fields to columns. It also incudes interactions like expanding and collapsing the parent records.

![TreeGrid](https://ej2.syncfusion.com/products/images/tree-grid/readme.png)

> This is a commercial product and requires a paid license for possession or use. Syncfusion’s licensed software, including this component, is subject to the terms and conditions of Syncfusion's EULA https://www.syncfusion.com/eula/es. To acquire a license, you can purchase one at https://www.syncfusion.com/sales/products or start a free 30-day trial here https://www.syncfusion.com/account/manage-trials/start-trials.
> A free community license <https://www.syncfusion.com/products/communitylicense> is also available for companies and individuals whose organizations have less than $1 million USD in annual gross revenue and five or fewer developers.

## Setup

To install TreeGrid and its dependent packages, use the following command.

```sh
npm install @syncfusion/ej2-vue-treegrid
```

## Resources

* [Getting Started](https://ej2.syncfusion.com/vue/documentation/tree-grid/getting-started/?no-cache=1)
* [View Online Demos](https://ej2.syncfusion.com/vue/demos/#/material/tree-grid/default.html)
* [Product Page](https://www.syncfusion.com/vue-ui-components/treegrid)

## Supported Frameworks

TreeGrid component is also offered in following list of frameworks.

1. [Angular](https://github.com/syncfusion/ej2-angular-ui-controls/tree/master/components/treegrid)
2. [React](https://github.com/syncfusion/ej2-react-ui-components/tree/master/components/treegrid)
3. [ASP.NET Core](https://www.syncfusion.com/aspnet-core-ui-controls/treegrid)
4. [ASP.NET MVC](https://www.syncfusion.com/aspnet-mvc-ui-controls/treegrid)
5. [JavaScript (ES5)](https://www.syncfusion.com/javascript-ui-controls/treegrid)

## Key Features

* [**Data sources**](https://ej2.syncfusion.com/vue/demos/#/material/tree-grid/localdata.html) - Bind the TreeGrid component with an array of JSON objects or DataManager.
* [**Sorting**](https://ej2.syncfusion.com/vue/demos/#/material/tree-grid/sorting.html) - Supports n levels of sorting.
* [**Filtering**](https://ej2.syncfusion.com/vue/demos/#/material/tree-grid/filtering.html) - Offers filter UI such as filter bar and menu at each column to filter data.
* [**Paging**](https://ej2.syncfusion.com/vue/demos/#/material/tree-grid/paging.html) - Provides the option to easily switch between pages using the pager bar.
* [**Editing**](https://ej2.syncfusion.com/vue/demos/#/material/tree-grid/inline-editing.html) - provides the options for create, read, update, and delete operations.
* **Columns** - The column definitions are used as the dataSource schema in the TreeGrid. This plays a vital role in rendering column values in the required format.
  * [**Reordering**](https://ej2.syncfusion.com/vue/demos/#/material/tree-grid/reorder.html) - Allows you to drag any column and drop it at any position in the TreeGrid’s column header row, allowing columns to be repositioned.
  * [**Resizing**](https://ej2.syncfusion.com/vue/demos/#/material/tree-grid/resizing.html) - Resizing allows changing column width on the fly by simply dragging the right corner of the column header.
  * [**Cell Styling**](https://ej2.syncfusion.com/vue/demos/#/material/tree-grid/conditionalformatting.html) - TreeGrid cell styles can be customized either by using CSS or programmatically.
  * [**Selection**](https://ej2.syncfusion.com/vue/demos/#/material/tree-grid/selection.html) - Rows or cells can be selected in the TreeGrid. One or more rows or cells can also be selected by holding Ctrl or Command, or programmatically.
  * [**Templates**](https://ej2.syncfusion.com/vue/demos/#/material/tree-grid/columntemplate.html) - Templates can be used to create custom user experiences in the TreeGrid.
* [**Aggregation**](https://ej2.syncfusion.com/vue/demos/#/material/tree-grid/aggregate.html) - Provides the option to easily visualized the Aggregates for column values.
* [**Context menu**](https://ej2.syncfusion.com/vue/demos/#/material/tree-grid/contextmenu.html) -The context menu provides a list of actions to be performed in the TreeGrid. It appears when a cell, header, or the pager is right-clicked.
* [**Export**](https://ej2.syncfusion.com/vue/demos/#/material/tree-grid/export.html) - Provides the options to Export the TreeGrid data to Excel, PDF, and CSV formats.
* **RTL support** - Provides a full-fledged right-to-left mode which aligns content in the TreeGrid control from right to left.
* **Localization** - Provides inherent support to localize the UI.

## Support

Product support is available through following mediums.

* Creating incident in Syncfusion [Direct-trac](https://www.syncfusion.com/support/directtrac/incidents?utm_source=npm&utm_campaign=grid) support system or [Community forum](https://www.syncfusion.com/forums/essential-js2?utm_source=npm&utm_campaign=grid).
* New [GitHub issue](https://github.com/syncfusion/ej2-javascript-ui-controls/issues/new).
* Ask your query in Stack Overflow with tag `syncfusion`, `ej2`.

## License

Check the license detail [here](https://github.com/syncfusion/ej2-javascript-ui-controls/blob/master/license?utm_source=npm&utm_campaign=grid).

## Changelog

Check the changelog [here](https://github.com/syncfusion/ej2-javascript-ui-controls/blob/master/controls/treegrid/CHANGELOG.md?utm_source=npm&utm_campaign=grid)

&copy; Copyright 2019 Syncfusion, Inc. All Rights Reserved. The Syncfusion Essential Studio license and copyright applies to this distribution.